/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"fmt"
)

// Frequency the model 'Frequency'
type Frequency string

// List of Frequency
const (
	HOURLY Frequency = "hourly"
	DAILY Frequency = "daily"
	WEEKLY Frequency = "weekly"
	MONTHLY Frequency = "monthly"
)

// All allowed values of Frequency enum
var AllowedFrequencyEnumValues = []Frequency{
	"hourly",
	"daily",
	"weekly",
	"monthly",
}

func (v *Frequency) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := Frequency(value)
	for _, existing := range AllowedFrequencyEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid Frequency", value)
}

// NewFrequencyFromValue returns a pointer to a valid Frequency
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewFrequencyFromValue(v string) (*Frequency, error) {
	ev := Frequency(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for Frequency: valid values are %v", v, AllowedFrequencyEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v Frequency) IsValid() bool {
	for _, existing := range AllowedFrequencyEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to Frequency value
func (v Frequency) Ptr() *Frequency {
	return &v
}

type NullableFrequency struct {
	value *Frequency
	isSet bool
}

func (v NullableFrequency) Get() *Frequency {
	return v.value
}

func (v *NullableFrequency) Set(val *Frequency) {
	v.value = val
	v.isSet = true
}

func (v NullableFrequency) IsSet() bool {
	return v.isSet
}

func (v *NullableFrequency) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFrequency(val *Frequency) *NullableFrequency {
	return &NullableFrequency{value: val, isSet: true}
}

func (v NullableFrequency) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFrequency) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

